function [statsDefects,stats] = getStatsOnDefects(BW)

%% Use feature analysis to identify broken objects
[labeled,numObjects] = bwlabel(BW,4);
stats = regionprops(labeled,'Eccentricity','Area','BoundingBox');
areas = [stats.Area];
minSize = mean(areas) - 0.25 * std(areas);
eccentricities = [stats.Eccentricity];
idxOfDefects = find(areas < minSize & eccentricities > .5);
statsDefects = stats(idxOfDefects);